#!/bin/bash
MySQLuser='*** your username here ***'
MySQLpass='*** your password here ***'
MySQLDB='VZManagement'
MySQLhost='localhost'
TempFile='*** path to your website here *** /var/www/apache2/tempvzkeyrefresh.sh'
TempURL='https://*** your FQDN here ***/tempvzkeyrefresh.sh --no-check-certificate' # remove --no-check-certificate if you buy a cert
 
QueryVZhosts='SELECT ID, PrimaryIP, Hostname, SSHUser FROM VZHosts WHERE active=true ORDER BY Hostname'
QueryVZcontainers='SELECT CTID FROM VZContainers WHERE VZHostID='
QueryVZpollLast='SELECT ID FROM VZPollEvents ORDER BY DateStamp DESC LIMIT 1'
QueryVZpubKeys='(SELECT SSHPubKey FROM StaffSSHPubKeys WHERE active=true) UNION (SELECT SSHPubKey FROM VZHosts WHERE active=true)'
 
touch $TempFile
echo "rm -f .ssh/authorized_keys" > $TempFile
echo "touch .ssh/authorized_keys" >> $TempFile
mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZpubKeys" | while read SSHPubKey; do
        if [ "$SSHPubKey" != "" ]; then
                echo "echo '$SSHPubKey' >> .ssh/authorized_keys " >> $TempFile
        fi
done
 
 
mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZpollLast" | while read PollID; do
        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhosts" | while read HostID PrimaryIP Hostname SSHUser; do
                ssh -t -t $SSHUser@$PrimaryIP <<-EOF
                        wget $TempURL
                        chmod 755 tempvzkeyrefresh.sh
                        ./tempvzkeyrefresh.sh
                        rm -f tempvzkeyrefresh.sh
                        exit
                EOF
        done
done
 
rm $TempFile
