#!/bin/bash
MySQLuser='*** your username here ***'
MySQLpass='*** your password here ***'
MySQLDB='VZManagement'
MySQLhost='localhost'
TempFile='tempvzcpubalance'
 
VZtype='dedi' # VZTypes: dedi (dedicated VPS), cloud (shared hosting), mixed (as it says on the tin), internal (other)
VZcpuAllowance='1000'
 
QueryVZhosts='SELECT ID, PrimaryIP, Hostname, SSHUser FROM VZHosts WHERE VZType="$VZtype" active=true ORDER BY Hostname'
QueryVZcontainers='SELECT CTID FROM VZContainers WHERE VZHostID='
 
QueryVZpollLast='SELECT ID FROM VZPollEvents ORDER BY DateStamp DESC LIMIT 1'
 
mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZpollLast" | while read PollID; do
        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhosts" | while read HostID PrimaryIP Hostname SSHUser; do
                touch $TempFile
                mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainers'$HostID' AND VZPollEventID='$PollID'" | while read CTID; do
                        echo "vzctl set $CTID --cpuunits $VZcpuAllowance --save;" >> $TempFile
                done
                echo "exit" >> $TempFile
                ssh -t -t $SSHUser@$PrimaryIP < $TempFile
                rm $TempFile
        done
done
