-- phpMyAdmin SQL Dump
-- version 3.4.11.1deb1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Feb 11, 2013 at 11:55 AM
-- Server version: 5.5.28
-- PHP Version: 5.4.4-11
 
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";
 
 
/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
 
--
-- Database: `VZManagement`
--
 
-- --------------------------------------------------------
 
--
-- Table structure for table `StaffSSHPubKeys`
--
 
CREATE TABLE IF NOT EXISTS `StaffSSHPubKeys` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(50) NOT NULL,
  `SSHPubKey` text NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 
-- --------------------------------------------------------
 
--
-- Table structure for table `VZContainers`
--
 
CREATE TABLE IF NOT EXISTS `VZContainers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `VZPollEventID` int(11) NOT NULL,
  `VZHostID` int(11) NOT NULL,
  `PrimaryIP` varchar(15) NOT NULL,
  `CTID` varchar(20) NOT NULL,
  `Hostname` varchar(150) NOT NULL,
  `Status` varchar(15) NOT NULL,
  `CPUusage` int(6) NOT NULL,
  `MemUsage` int(6) NOT NULL,
  `MemLimit` int(6) NOT NULL,
  `SecondaryIPs` varchar(255) NOT NULL,
  `DiskQuotaStatus` varchar(4) NOT NULL DEFAULT 'Yes',
  `DiskMountPoint` text NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `VZHost` (`VZHostID`),
  KEY `VZPollEventID` (`VZPollEventID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 
-- --------------------------------------------------------
 
--
-- Table structure for table `VZHosts`
--
 
CREATE TABLE IF NOT EXISTS `VZHosts` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `PrimaryIP` varchar(15) NOT NULL,
  `Hostname` varchar(100) NOT NULL,
  `SSHUser` varchar(10) NOT NULL DEFAULT 'root',
  `SSHPubKey` text NOT NULL,
  `SSHPubKeyLength` smallint(6) NOT NULL DEFAULT '0',
  `SSHPubKeyDate` varchar(20) NOT NULL,
  `VZType` varchar(10) NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 
-- --------------------------------------------------------
 
--
-- Table structure for table `VZPollEvents`
--
 
CREATE TABLE IF NOT EXISTS `VZPollEvents` (
  `ID` int(11) NOT NULL AUTO_INCREMENT,
  `DateStamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `Active` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 
--
-- Constraints for dumped tables
--
 
--
-- Constraints for table `VZContainers`
--
ALTER TABLE `VZContainers`
  ADD CONSTRAINT `VZContainers_ibfk_1` FOREIGN KEY (`VZHostID`) REFERENCES `VZHosts` (`ID`),
  ADD CONSTRAINT `VZContainers_ibfk_2` FOREIGN KEY (`VZPollEventID`) REFERENCES `VZPollEvents` (`ID`);
 
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
